function [G0, G1] = ETAQADepModel(D0,D1,S0,S1, maxLag)

    NA = size(D0,1);
    NS = size(S0,1);
    N = NA*NS;
    IA = eye(NA);
    IS = eye(NS);
    
    L = kron(D0,IS)+kron(IA,S0);
    B = kron(IA,S1);
    F = kron(D1,IS);
    L0 = kron(D0,IS);
    
    G = QBDFundamentalMatrices(B, L, F, 'G', 1e-15);   
    
    G0 = zeros((maxLag+1)*N);
    G1 = zeros((maxLag+1)*N);
    for i=1:maxLag+1
        if i==1
            G0((i-1)*N+1:i*N,(i-1)*N+1:i*N) = L0;
        elseif i==maxLag+1
            G0((i-1)*N+1:i*N,(i-1)*N+1:i*N) = L+F;
        else
            G0((i-1)*N+1:i*N,(i-1)*N+1:i*N) = L;
        end
        if i<maxLag+1
            G0((i-1)*N+1:i*N,i*N+1:(i+1)*N) = F;
        end
        if i>1
            if i<maxLag+1
                G1((i-1)*N+1:i*N,(i-2)*N+1:(i-1)*N) = B;
            else
                G1((i-1)*N+1:i*N,(i-2)*N+1:(i-1)*N) = B-F*G;
                G1((i-1)*N+1:i*N,(i-1)*N+1:i*N) = F*G;
            end
        end
    end
end

