function Y = JointPdfFromRAP (D0, D1, x1, x2, lag)

if nargin<5
    lag = 2;
end

P = inv(-D0)*D1;
alpha = DRPSolve(P);

Pterm = P^(lag-2);

Y = zeros(length(x1),length(x2));
for i=1:length(x1)
    for j=1:length(x2)
        Y(i,j) = sum(alpha*expm(D0*x1(i))*D1*Pterm*expm(D0*x2(j))*D1);
    end
end

end

