function d = MAPDistAcf(A0,A1,B0,B1,alA,alB)

    if nargin<6
        alB = DTMCSolve(inv(-B0)*B1);
    end
    if nargin<5
        alA = DTMCSolve(inv(-A0)*A1);
    end

    momA = MomentsFromME (alA, A0, 2);
    momB = MomentsFromME (alB, B0, 2);
    
    mA = momA(1);
    mB = momB(1);
    varA = momA(2)-mA^2;
    varB = momB(2)-mB^2;
    
    d = (MGeoMulSum(A0,A1,A0,A1,alA,alA) - momA(2)*momA(2)/4) / varA / varA ...
        - 2*(MGeoMulSum(A0,A1,B0,B1,alA,alB) - momA(2)*momB(2)/4) / varA / varB ...      
        + (MGeoMulSum(B0,B1,B0,B1,alB,alB)   - momB(2)*momB(2)/4) / varB / varB;
end

