function d = MAPDistLag1 (A0,A1,B0,B1,alA,alB)

    if nargin<7
        alB = DTMCSolve(inv(-B0)*B1);
    end
    if nargin<6
        alA = DTMCSolve(inv(-A0)*A1);
    end

    a = sum(-A0,2);
    b = sum(-B0,2);
    
    Z_AB = lyap(A0',B0,alA'*alB);
    Z_AA = lyap(A0',A0,alA'*alA);
    Z_BB = lyap(B0',B0,alB'*alB);
    
    X_AB = lyap(A0,B0',a*b');
    X_AA = lyap(A0,A0',a*a');
    X_BB = lyap(B0,B0',b*b');
    
    vA1 = reshape(A1,numel(A1),1);
    vB1 = reshape(B1,numel(B1),1);

    d = vB1'*kron(X_BB,Z_BB)*vB1 + vA1'*kron(X_AA,Z_AA)*vA1 - 2*vA1'*kron(X_AB,Z_AB)*vB1;
end

