function d = MGeoMulSum(A0,A1,B0,B1,alA,alB)

    if nargin<7
        alB = DTMCSolve(inv(-B0)*B1);
    end
    if nargin<6
        alA = DTMCSolve(inv(-A0)*A1);
    end

    A0i = inv(-A0);
    B0i = inv(-B0);
    
    PAh = A0i*A1-ones(length(alA),1)*alA;
    PBh = B0i*B1-ones(length(alB),1)*alB;
    
    M = eye(size(A0,1)*size(B0,1))-kron(PBh',PAh);
    if rcond(M)<1e-10
        d = 1/rcond(M);
    else
%        d = kron(sum(B0i,2)', alA*A0i) * inv(M) * kron((alB*B0i)',sum(A0i,2));
        X = dlyap(PAh, PBh, sum(A0i,2)*(alB*B0i));    
        d = sum(alA*A0i*X*B0i);
    end
end

