function [B1,d] = OptimDist (A0,A1,alA,B0,alB,L)

    a = sum(-A0,2);
    b = sum(-B0,2);
    NB = size(B0,1);
    Aeq = [kron(eye(NB),alB*inv(-B0)) ; kron(ones(1,NB),eye(NB))];
    beq = [alB';b];

    function di = myfun(x)
        B1x = reshape(x, NB, NB);
        di = MAPDist (A0,A1,B0,B1x,L,alA,alB);
    end

    warning off;

    if L==1
        % quadratic programming for lag-1
        Z_AB = lyap(A0',B0,alA'*alB);
        Z_AA = lyap(A0',A0,alA'*alA);
        Z_BB = lyap(B0',B0,alB'*alB);

        X_AB = lyap(A0,B0',a*b');
        X_AA = lyap(A0,A0',a*a');
        X_BB = lyap(B0,B0',b*b');

        vA1 = reshape(A1,numel(A1),1);
        options = optimset('Display','off');
%        vB1 = quadprog(kron(X_BB,Z_BB), -vA1'*kron(X_AB,Z_AB), [], [], Aeq, beq, zeros(NB*NB,1), [], [], options);   
        vB1 = quadprog(kron(X_BB,Z_BB), -vA1'*kron(X_AB,Z_AB), [], [], Aeq, beq, 1e-6*ones(NB*NB,1), [], [], options);   
        B1 = reshape(vB1, NB, NB);
        d = vB1'*kron(X_BB,Z_BB)*vB1 + vA1'*kron(X_AA,Z_AA)*vA1 - 2*vA1'*kron(X_AB,Z_AB)*vB1;
    else
        %========= BRUTE FORCE ============
        options = optimset('Display','off');
%        [vB1, d] = fmincon(@myfun, rand(NB*NB,1), [], [], Aeq, beq, zeros(NB*NB,1), [], [], options);   
        [vB1, d] = fmincon(@myfun, rand(NB*NB,1), [], [], Aeq, beq, 1e-6*ones(NB*NB,1), [], [], options);   
        B1 = reshape(vB1, NB, NB);
    end
    
    warning on;
end

